if($AddOn__Vehicle_Horse){exec("Add-Ons/Vehicle_Horse/Server.cs");}
exec("./Support.cs");

function serverCmdNormalMe(%Client)
{
	NormalMe(%Client);
	%Player = %Client.player;
	%Player.playthread(0,root);
	%Player.setScale("1 1 1");
}

function serverCmdCloakMe(%Client)
{
	if(FFCConditionsCheck(%Client,'',"Cloak"))
	{
		clearAllPlayerNodes(%Client.player);
		if(%Client.player.getDataBlock() $= "HorseArmor")
		{
			%Client.Player.hideNode(head);
			%Client.Player.hideNode(body);
		}
		%Client.player.setShapeName("");
	}
}

function serverCmdDogMe(%Client,%Color)
{
	if(FFCConditionsCheck(%Client,'',"Dog",%Color))
	{
		NormalMe(%Client);
		%Client.isDog = 1;
		%Client.FFCColor = %Color;
		%Player = %Client.player;
		clearAllPlayerNodes(%Player);
		%Player.setDataBlock("SmallAnimalArmor");
		%Player.hideNode(head);
		%Player.hideNode(body);
		if(%Player.getScale() $= "1 1 1"){%Player.setScale("0.5 0.5 0.5");}
		switch$(%Color)
		{
			case "":%Player.mountimage(DogImage,1);
			case "red":%Player.mountimage(DogRedImage,1);
			case "blue":%Player.mountimage(DogBlueImage,1);
			case "pink":%Player.mountimage(DogPinkImage,1);
			case "green":%Player.mountimage(DogGreenImage,1);
			case "black":%Player.mountimage(DogBlackImage,1);
			case "white":%Player.mountimage(DogWhiteImage,1);
			case "yellow":%Player.mountimage(DogYellowImage,1);
			case "orange":%Player.mountimage(DogOrangeImage,1);
			case "purple":%Player.mountimage(DogPurpleImage,1);
		}
	}
}

function serverCmdFloatingHeadMe(%Client,%Arg)
{
	if(FFCConditionsCheck(%Client,'',"FloatingHead"))
	{
		NormalMe(%Client);
		%Player = %Client.player;
		%Client.isFloatingHead = 1;
		clearAllPlayerNodes(%Client.player);
		serverCmdHead(%Client,%Arg);
	}
}

function serverCmdHead(%Client,%Arg)
{
	%Player = %Client.player;
	%Player.unMountImage(2);
	%Player.hideNode("headSkin");
	%Player.hideNode($hat[%Client.hat]);
	if($accent[%Client.accent] !$= "none" && %Client.accent)
	{
		if(%Client.hat == 1){%Player.HideNode($accent[4]);}
		else if(%Client.hat > 0){%Player.HideNode($accent[%Client.accent]);}
	}
	switch$(%Arg)
	{
		case "":
			unHideHeadNodes(%Client);
			%Client.HeadType = "";
		case "Bear":
			%Player.mountimage(PBearImage,2);
			%Client.HeadType = %Arg;
		case "Skele":
			%Player.mountImage(SkeleHeadImage,2);
			%Client.HeadType = %Arg;
	}
}

function serverCmdHorseMe(%Client)
{
	if(FFCConditionsCheck(%Client,'',"Horse"))
	{
		NormalMe(%Client);
		%Client.isHorse = 1;
		%Player = %Client.player;
		%Player.setDataBlock("HorseArmor");
		%Player.unhideNode(head);
		%Player.unhideNode(body);
		%Player.setNodeColor(Body,getColorIDTable(%Client.currentColor));
	}
}

function serverCmdMonkeyMe(%Client,%Color)
{
	if(FFCConditionsCheck(%Client,'',"Monkey",%Color))
	{
		NormalMe(%Client);
		%Client.isMonkey = 1;
		%Client.FFCColor = %Color;
		%Player = %Client.player;
		clearAllPlayerNodes(%Player);
		%Player.hideNode(head);
		%Player.hideNode(body);
		switch$(%Color)
		{
			case "":%Player.mountimage(MonkeyImage,1);
			case "red":%Player.mountimage(MonkeyRedImage,1);
			case "blue":%Player.mountimage(MonkeyBlueImage,1);
			case "pink":%Player.mountimage(MonkeyPinkImage,1);
			case "green":%Player.mountimage(MonkeyGreenImage,1);
			case "black":%Player.mountimage(MonkeyBlackImage,1);
			case "white":%Player.mountimage(MonkeyWhiteImage,1);
			case "yellow":%Player.mountimage(MonkeyYellowImage,1);
			case "orange":%Player.mountimage(MonkeyOrangeImage,1);
			case "purple":%Player.mountimage(MonkeyPurpleImage,1);
		}
	}
}

function serverCmdSkeleMe(%Client)
{
	if(FFCConditionsCheck(%Client,'',"Skeleton"))
	{
		NormalMe(%Client);
		%Client.isSkeleton = 1;
		%Player = %Client.player;
		%White = "1 1 1 1";
		ClearAllPlayerNodes(%Player);
		%Player.unhideNode(RHand);
		%Player.unhideNode(LHand);
		%Player.unhideNode(RArmSlim);
		%Player.unhideNode(LArmSlim);
		%Player.unhideNode(RShoe);
		%Player.unhideNode(LShoe);
		%Client.larmColor = %White;
		%Client.llegColor = %White;
		%Client.rarmColor = %White;
		%Client.rlegColor = %White;
		%Client.rhandColor = %White;
		%Client.lhandColor = %White;
		%Player.setNodeColor(RHand,%White);
		%Player.setNodeColor(LHand,%White);
		%Player.setNodeColor(RArmSlim,%White);
		%Player.setNodeColor(LArmSlim,%White);
		%Player.setNodeColor(RShoe,%White);
		%Player.setNodeColor(LShoe,%White);
		%Player.mountImage(SkeleHeadImage,2);
		%Player.mountImage(SkeleBodyImage,1);
	}
}

function serverCmdSmurfMe(%Client)
{
	if(FFCConditionsCheck(%Client,'',"Smurf"))
	{
		NormalMe(%Client);
		%Client.isSmurf = 1;
		%Player = %Client.player;
		%LightBlue = "0.106 0.459 0.7969 1";
		%White = "1 1 1 1";
		ClearAllPlayerNodes(%Player);
		%Player.setScale("0.2 0.2 0.2");
		%Player.unhideNode(KnitHat);
		%Player.unhideNode(HeadSkin);
		%Player.unhideNode(Chest);
		%Player.unhideNode(Pants);
		%Player.unhideNode(LShoe);
		%Player.unhideNode(RShoe);
		%Player.unhideNode(LArm);
		%Player.unhideNode(RArm);
		%Player.unhideNode(LHand);
		%Player.unhideNode(RHand);
		%Client.hatColor = %White;
		%client.headColor = %LightBlue;
		%Client.chestColor = %LightBlue;
		%Client.hipColor = %White;
		%Client.larmColor = %LightBlue;
		%Client.lhandColor = %LightBlue;
		%Client.llegColor = %White;
		%Client.rarmColor = %LightBlue;
		%Client.rhandColor = %LightBlue;
		%Client.rlegColor = %White;
		%Player.setNodeColor(KnitHat,%White);
		%Player.setNodeColor(HeadSkin,%LightBlue);
		%Player.setNodeColor(Chest,%LightBlue);
		%Player.setNodeColor(Pants,%White);
		%Player.setNodeColor(LShoe,%White);
		%Player.setNodeColor(RShoe,%White);
		%Player.setNodeColor(LArm,%LightBlue);
		%Player.setNodeColor(RArm,%LightBlue);
		%Player.setNodeColor(LHand,%LightBlue);
		%Player.setNodeColor(RHand,%LightBlue);
		%Player.setDecalName("AAA-None");
	}
}

function serverCmdResizeMe(%Client,%Arg1,%Arg2,%Arg3)
{
	if(FFCConditionsCheck(%Client,'',"Resize"))
	{
		%Arg1 = mRound(%Arg1);
		%Arg2 = mRound(%Arg2);
		%Arg3 = mRound(%Arg3);
		if(%Arg1 > 5){%Arg1 = 5;}
		if(%Arg2 > 5){%Arg2 = 5;}
		if(%Arg3 > 5){%Arg3 = 5;}
		if(%Arg1 < 0.1){%Arg1 = 0.1;}
		if(%Arg2 < 0.1){%Arg2 = 0.1;}
		if(%Arg3 < 0.1){%Arg3 = 0.1;}
		FFCResizeMe(%Client,%Arg1,%Arg2,%Arg3);
	}
}

function serverCmdExplode(%Client,%Arg,%Arg2)
{
	if(!%Client.explodefloodprotect)
	{
		if(%Client.isSuperAdmin && %Arg){%Victim = findclientbyname(%Arg);}
		else{%Victim = %Client;}
		%Player = %Victim.player;
		if(isObject(%Player)&& %Arg $= "Head" || %Arg $= "Body" || %Arg $= "LHand" || %Arg $= "Pants" || %Arg $= "LFoot" || %Arg $= "RFoot" || %Arg $= "RHand")
		{
			switch$(%Arg)
			{
				case  "Head":
					HideHeadNodes(%Player);
				case  "Body":
					for(%i=0;%i<5;%i++) %Player.unMountImage(%i);
					for(%i=0;$chest[%i]!$= "";%i++) %Player.hideNode($chest[%i]);
					for(%i=0;$pack[%i]!$= "";%i++) %Player.hideNode($pack[%i]);
					for(%i=0;$secondPack[%i]!$= "";%i++) %Player.hideNode($secondPack[%i]);
					for(%i=0;$LArm[%i]!$= "";%i++) %Player.hideNode($LArm[%i]);
					for(%i=0;$RArm[%i]!$= "";%i++) %Player.hideNode($RArm[%i]);
				case "LHand":
					for(%i=0;$LHand[%i]!$= "";%i++) %Player.hideNode($LHand[%i]);
				case "Pants":
					for(%i=0;$hip[%i]!$= "";%i++) %Player.hideNode($hip[%i]);
				case "LFoot":
					for(%i=0;$LLeg[%i]!$= "";%i++) %Player.hideNode($LLeg[%i]);
				case "RFoot":
					for(%i=0;$RLeg[%i]!$= "";%i++) %Player.hideNode($RLeg[%i]);
				case "RHand":
					for(%i=0;$RHand[%i]!$= "";%i++) %Player.hideNode($RHand[%i]);
			}
			if(%Client $= %Victim){messageAll('','\c3%1 \c0has blown up their own %2.',%Client.name,%Arg);}
			else{messageAll('','\c3%1 \c0blew up \c3%2s \c0%3.',%Client.name,%Victim.name,%Arg);}
			%Player.emote(HeadExplosionImage);
			%Client.explodefloodprotect = 1;
			schedule(5000,0,"ExplodeTimeReset",%Client);

		}			
	}
	else
	{
		CenterPrint(%Client,"Please wait to use this again.",1,2);	
	}
}

function serverCmdMount(%Client,%Arg,%Arg2)
{
	%Victim = findclientbyname(%Arg2);
	if(FFCConditionsCheck(%Client,%Victim))
	{
		switch$(%Arg)
		{
			case   "Hat":%Pos = 5;
			case  "Head":%Pos = 2;
			case  "Body":%Pos = 7;
			case "LHand":%Pos = 1;
			case "Pants":%Pos = 8;
			case "LFoot":%Pos = 4;
			case "RFoot":%Pos = 3;
		}
		if(!%Pos){CenterPrint(%Client,"Mount point not found.",1,2);}
		else if(%Client !$= %Victim){%Victim.player.mountObject(%Client.player,%Pos);}
	}
}

function serverCmdStatus(%Client,%Arg)
{
	if(%Arg !$= "" && strLen(%Arg) < 10)
	{
		%Client.Status = %Arg;
		%Status = "["@%Arg@"]" SPC %Client.name;
		%Client.player.setShapeName(%Status);
		messageClient(%Client,'','\c3Updated your status to \c0%1',%Arg);
	}
	else
	{
		%Client.Status = "";
		%Client.player.setShapeName(%Client.name);
		messageClient(%Client,'','\c3Updated your status to \c0Normal');
	}
}

function serverCmdFFCHelp(%Client,%Arg)
{
	switch(%Arg)
	{
		case 0:
			commandToClient(%Client,'MessageBoxOK',"Fun Cmds Page 1","/CloakMe (Turns you invisible)\n/Dogme [Color] (Turns you into a dog)\n/Explode [bodypart] (Explodes specified part)\n/FloatingHeadMe (Turns you into a floating head)\n/HorseMe (Turns you into a horse)\n/MonkeyMe [Color] (Turns you into a monkey)\n/FFCHelp 2 (for Page 2)");
		case 2:
			commandToClient(%Client,'MessageBoxOK',"Fun Cmds Page 2","/Mount partname bodypart (Mounts to player)\n/NormalMe (Turns you back to normal)\n/ResizeMe X Y Z (XYZ are your diminsions)\n/SkeleMe (Turns you into a skeleton)\n/SmurfMe (Turns you into a smurf)\n/Status status (Sets status)");
	}
}

function serverCmdPlayDead(%Client){if(FFCConditionsCheck(%Client,'',"PlayDead")){%Client.player.playthread(0,death1);}}

function serverCmdDryHump(%Client){%Client.player.playthread(0,crouchBack);}

function serverCmdFFCSetMiniGameData(%Client,%Info1,%Info2,%Info3)
{
	%Minigame = %Client.minigame;

	%Minigame.Cloak = getWord(%Info1,0);
	%Minigame.FloatingHead = getWord(%Info1,1);
	%Minigame.Horse = getWord(%Info1,2);
	%Minigame.Monkey = getWord(%Info1,3);

	%Minigame.PlayDead = getWord(%Info2,0);
	%Minigame.Resize = getWord(%Info2,1);
	%Minigame.Skeleton = getWord(%Info2,2);
	%Minigame.Smurf = getWord(%Info2,3);

	%Minigame.Dog = %Info3;
}

package FFCServer
{
	function GameConnection::OnClientEnterGame(%this)
	{
		Parent::OnClientEnterGame(%this);
		cacheAvatarColor(%this);
	}

	function GameConnection::createplayer(%this,%spawnpoint)
	{
		Parent::createplayer(%this,%spawnpoint);
		if(%this.isFloatingHead){serverCmdFloatingHeadMe(%this,%this.HeadType);}
		else if(%this.isHorse){serverCmdHorseMe(%this);}
		else if(%this.isMonkey){serverCmdMonkeyMe(%this,%this.FFCColor);}
		else if(%this.isSmurf){serverCmdSmurfMe(%this);}
		else if(%this.isSkeleton){serverCmdSkeleMe(%this);}
		else if(%this.isDog){serverCmdDogMe(%this,%this.FFCColor);}
		if(%this.HeadType !$= ""){serverCmdHead(%this,%this.HeadType);}
	}

	function serverCmdUpdateBodyColors(%Client,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l,%m,%n,%facedecal)
	{
		Parent::serverCmdUpdateBodyColors(%Client,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k,%l,%m,%n,%facedecal);
		cacheAvatarColor(%Client);
	}
};
ActivatePackage(FFCServer);
